=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2011-02-22 00:30:21 +0000
+++ client/drizzle.cc	2011-02-22 04:09:52 +0000
@@ -430,7 +430,7 @@
 static void add_int_to_prompt(int toadd);
 static int get_result_width(drizzle_result_st *res);
 static int get_field_disp_length(drizzle_column_st * field);
-static const char * strcont(register const char *str, register const char *set);
+static const char * strcont(const char *str, const char *set);
 
 /* A class which contains information on the commands this program
    can understand. */
@@ -2762,7 +2762,7 @@
 static int
 com_help(string *buffer, const char *)
 {
-  register int i, j;
+  int i, j;
   char buff[32], *end;
   std::vector<char> output_buff;
   output_buff.resize(512);
@@ -4779,9 +4779,9 @@
     if there isn't anything found.
 */
 
-static const char * strcont(register const char *str, register const char *set)
+static const char * strcont(const char *str, const char *set)
 {
-  register const char * start = (const char *) set;
+  const char * start = (const char *) set;
 
   while (*str)
   {

=== modified file 'client/drizzleslap.cc' (properties changed: +x to -x)
--- client/drizzleslap.cc	2011-02-17 00:14:13 +0000
+++ client/drizzleslap.cc	2011-02-21 21:45:55 +0000
@@ -245,7 +245,7 @@
 
 static long int timedif(struct timeval a, struct timeval b)
 {
-  register int us, s;
+  int us, s;
 
   us = a.tv_usec - b.tv_usec;
   us /= 1000;

=== modified file 'drizzled/base.h'
--- drizzled/base.h	2011-02-12 17:47:50 +0000
+++ drizzled/base.h	2011-02-22 02:50:14 +0000
@@ -25,7 +25,7 @@
  * @TODO Convert HA_XXX defines into enums and/or bitmaps
  */
 
-#include "definitions.h"
+#include <drizzled/definitions.h>
 
 #ifndef DRIZZLED_BASE_H
 #define DRIZZLED_BASE_H

=== modified file 'drizzled/create_field.cc'
--- drizzled/create_field.cc	2011-02-18 16:15:33 +0000
+++ drizzled/create_field.cc	2011-02-21 22:12:35 +0000
@@ -375,7 +375,7 @@
         /* Should be safe. */
         pack_length= 4;
 
-        List<String>::iterator it(*fld_interval_list);
+        List<String>::iterator it(fld_interval_list->begin());
         String *tmp;
         while ((tmp= it++))
           interval_list.push_back(tmp);

=== modified file 'drizzled/cursor.h'
--- drizzled/cursor.h	2011-02-17 00:14:13 +0000
+++ drizzled/cursor.h	2011-02-22 02:50:14 +0000
@@ -20,22 +20,18 @@
 #ifndef DRIZZLED_CURSOR_H
 #define DRIZZLED_CURSOR_H
 
-#include <drizzled/xid.h>
+#include <drizzled/atomics.h>
+#include <drizzled/definitions.h>
 #include <drizzled/discrete_interval.h>
+#include <drizzled/error_t.h>
+#include <drizzled/ha_statistics.h>
+#include <drizzled/handler_structs.h>
 #include <drizzled/identifier.h>
-#include <drizzled/definitions.h>
 #include <drizzled/key_map.h>
-#include <drizzled/error_t.h>
-
-/* Definitions for parameters to do with Cursor-routines */
-
+#include <drizzled/message/table.h>
+#include <drizzled/sql_list.h>
 #include <drizzled/thr_lock.h>
-#include <drizzled/sql_list.h>
-#include <drizzled/handler_structs.h>
-#include <drizzled/ha_statistics.h>
-#include <drizzled/atomics.h>
-
-#include <drizzled/message/table.h>
+#include <drizzled/xid.h>
 
 #include <bitset>
 #include <algorithm>

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2011-02-22 00:20:06 +0000
+++ drizzled/drizzled.cc	2011-02-22 06:09:35 +0000
@@ -357,9 +357,6 @@
 
 DRIZZLED_API size_t transaction_message_threshold;
 
-/* Function declarations */
-bool drizzle_rm_tmp_tables();
-
 static void drizzle_init_variables(void);
 static void get_options();
 static void fix_paths();

=== modified file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	2011-02-17 00:14:13 +0000
+++ drizzled/drizzled.h	2011-02-22 06:09:35 +0000
@@ -68,7 +68,6 @@
 passwd *check_user(const char *user);
 void set_user(const char *user, passwd *user_info_arg);
 void clean_up(bool print_message);
-bool drizzle_rm_tmp_tables();
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/dtoa.cc'
--- drizzled/dtoa.cc	2011-02-17 00:14:13 +0000
+++ drizzled/dtoa.cc	2011-02-21 21:45:55 +0000
@@ -720,9 +720,9 @@
 }
 
 
-static int hi0bits(register ULong x)
+static int hi0bits(ULong x)
 {
-  register int k= 0;
+  int k= 0;
 
   if (!(x & 0xffff0000))
   {
@@ -756,8 +756,8 @@
 
 static int lo0bits(ULong *y)
 {
-  register int k;
-  register ULong x= *y;
+  int k;
+  ULong x= *y;
 
   if (x & 7)
   {
@@ -1069,7 +1069,7 @@
 
 static double ulp(double x)
 {
-  register Long L;
+  Long L;
   double a;
 
   L= (word0(x) & Exp_mask) - (P - 1)*Exp_msk1;

=== modified file 'drizzled/field_iterator.cc'
--- drizzled/field_iterator.cc	2011-02-21 18:33:47 +0000
+++ drizzled/field_iterator.cc	2011-02-22 00:55:58 +0000
@@ -57,7 +57,7 @@
 void Field_iterator_natural_join::set(TableList *table_ref)
 {
   assert(table_ref->join_columns);
-  column_ref_it.init(*(table_ref->join_columns));
+  column_ref_it= table_ref->join_columns->begin();
   cur_column_ref= column_ref_it++;
 }
 

=== modified file 'drizzled/foreign_key.cc'
--- drizzled/foreign_key.cc	2011-02-19 23:05:57 +0000
+++ drizzled/foreign_key.cc	2011-02-21 22:12:35 +0000
@@ -64,13 +64,13 @@
   pfkey->set_references_table_name(table->table.str);
 
   Key_part_spec *keypart;
-  List<Key_part_spec>::iterator col_it(cols);
+  List<Key_part_spec>::iterator col_it(cols.begin());
   while ((keypart= col_it++))
   {
     pfkey->add_column_names(keypart->field_name.str);
   }
 
-  List<Key_part_spec>::iterator ref_it(ref_cols);
+  List<Key_part_spec>::iterator ref_it(ref_cols.begin());
   while ((keypart= ref_it++))
   {
     pfkey->add_references_columns(keypart->field_name.str);
@@ -122,8 +122,8 @@
   if (a->columns.elements > b->columns.elements)
     return true;                                // Can't be prefix
 
-  List<Key_part_spec>::iterator col_it1(a->columns);
-  List<Key_part_spec>::iterator col_it2(b->columns);
+  List<Key_part_spec>::iterator col_it1(a->columns.begin());
+  List<Key_part_spec>::iterator col_it2(b->columns.begin());
   const Key_part_spec *col1, *col2;
 
 #ifdef ENABLE_WHEN_INNODB_CAN_HANDLE_SWAPED_FOREIGN_KEY_COLUMNS
@@ -166,8 +166,8 @@
 {
   CreateField  *sql_field;
   Key_part_spec *column;
-  List<Key_part_spec>::iterator cols(columns);
-  List<CreateField>::iterator it(table_fields);
+  List<Key_part_spec>::iterator cols(columns.begin());
+  List<CreateField>::iterator it(table_fields.begin());
   while ((column= cols++))
   {
     it= table_fields.begin();

=== modified file 'drizzled/function/func.cc'
--- drizzled/function/func.cc	2011-02-20 00:09:56 +0000
+++ drizzled/function/func.cc	2011-02-21 22:42:56 +0000
@@ -126,7 +126,7 @@
   args= tmp_arg;                                // If 2 arguments
   if (arg_count <= 2 || (args=(Item**) memory::sql_alloc(sizeof(Item*)*arg_count)))
   {
-    List<Item>::iterator li(list);
+    List<Item>::iterator li(list.begin());
     Item *item;
     Item **save_args= args;
 

=== modified file 'drizzled/function/str/replace.cc'
--- drizzled/function/str/replace.cc	2011-02-17 00:14:13 +0000
+++ drizzled/function/str/replace.cc	2011-02-21 21:45:55 +0000
@@ -43,7 +43,7 @@
   uint32_t from_length,to_length;
   bool alloced=0;
   const char *ptr,*end,*strend,*search,*search_end;
-  register uint32_t l;
+  uint32_t l;
   bool binary_cmp;
 
   null_value=0;
@@ -80,7 +80,7 @@
     {
         if (*ptr == *search)
         {
-          register char *i,*j;
+          char *i,*j;
           i=(char*) ptr+1; j=(char*) search+1;
           while (j != search_end)
             if (*i++ != *j++) goto skip;

=== modified file 'drizzled/function/str/trim.cc'
--- drizzled/function/str/trim.cc	2011-02-17 00:14:13 +0000
+++ drizzled/function/str/trim.cc	2011-02-21 21:45:55 +0000
@@ -95,7 +95,7 @@
   ptr= (char*) res->ptr();
   end= ptr+res->length();
   char *p=ptr;
-  register uint32_t l;
+  uint32_t l;
   if (remove_length == 1)
   {
     char chr=(*remove_str)[0];
@@ -175,7 +175,7 @@
   if (use_mb(res->charset()))
   {
     char *p=ptr;
-    register uint32_t l;
+    uint32_t l;
  loop:
     while (ptr + remove_length < end)
     {

=== modified file 'drizzled/ha_statistics.h'
--- drizzled/ha_statistics.h	2010-12-18 04:43:40 +0000
+++ drizzled/ha_statistics.h	2011-02-22 02:50:14 +0000
@@ -20,7 +20,7 @@
 #ifndef DRIZZLED_HA_STATISTICS_H
 #define DRIZZLED_HA_STATISTICS_H
 
-#include <drizzled/definitions.h>
+#include <drizzled/base.h>
 #include <time.h>
 
 namespace drizzled

=== modified file 'drizzled/internal/bmove_upp.cc'
--- drizzled/internal/bmove_upp.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/bmove_upp.cc	2011-02-21 21:45:55 +0000
@@ -31,8 +31,7 @@
 namespace internal
 {
 
-void bmove_upp(register unsigned char *dst, register const unsigned char *src,
-               register size_t len)
+void bmove_upp(unsigned char *dst, const unsigned char *src, size_t len)
 {
   while (len-- != 0) *--dst = *--src;
 }

=== modified file 'drizzled/internal/mf_iocache.cc'
--- drizzled/internal/mf_iocache.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/mf_iocache.cc	2011-02-21 21:45:55 +0000
@@ -70,15 +70,15 @@
 namespace internal
 {
 
-static int _my_b_read(register st_io_cache *info, unsigned char *Buffer, size_t Count);
-static int _my_b_write(register st_io_cache *info, const unsigned char *Buffer, size_t Count);
+static int _my_b_read(st_io_cache *info, unsigned char *Buffer, size_t Count);
+static int _my_b_write(st_io_cache *info, const unsigned char *Buffer, size_t Count);
 
 /**
  * @brief
  *   Lock appends for the st_io_cache if required (need_append_buffer_lock)   
  */
 inline
-static void lock_append_buffer(register st_io_cache *, int )
+static void lock_append_buffer(st_io_cache *, int )
 {
 }
 
@@ -87,7 +87,7 @@
  *   Unlock appends for the st_io_cache if required (need_append_buffer_lock)   
  */
 inline
-static void unlock_append_buffer(register st_io_cache *, int )
+static void unlock_append_buffer(st_io_cache *, int )
 {
 }
 
@@ -441,7 +441,7 @@
  * @retval 0 We succeeded in reading all data
  * @retval 1 Error: can't read requested characters
  */
-static int _my_b_read(register st_io_cache *info, unsigned char *Buffer, size_t Count)
+static int _my_b_read(st_io_cache *info, unsigned char *Buffer, size_t Count)
 {
   size_t length_local,diff_length,left_length, max_length;
   my_off_t pos_in_file_local;
@@ -552,7 +552,7 @@
  * @retval 0 Success
  * @retval 1 An error has occurred; st_io_cache to error state.
  */
-int _my_b_async_read(register st_io_cache *info, unsigned char *Buffer, size_t Count)
+int _my_b_async_read(st_io_cache *info, unsigned char *Buffer, size_t Count)
 {
   size_t length_local,read_length,diff_length,left_length,use_length,org_Count;
   size_t max_length;
@@ -740,7 +740,7 @@
  * @retval 0 On success
  * @retval 1 On error on write
  */
-int _my_b_write(register st_io_cache *info, const unsigned char *Buffer, size_t Count)
+int _my_b_write(st_io_cache *info, const unsigned char *Buffer, size_t Count)
 {
   size_t rest_length,length_local;
 
@@ -794,7 +794,7 @@
  *   As all write calls to the data goes through the cache,
  *   we will never get a seek over the end of the buffer.
  */
-int my_block_write(register st_io_cache *info, const unsigned char *Buffer, size_t Count,
+int my_block_write(st_io_cache *info, const unsigned char *Buffer, size_t Count,
 		   my_off_t pos)
 {
   size_t length_local;

=== modified file 'drizzled/internal/mf_pack.cc'
--- drizzled/internal/mf_pack.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/mf_pack.cc	2011-02-21 21:45:55 +0000
@@ -50,12 +50,12 @@
     #  length of new name
 */
 
-static size_t cleanup_dirname(register char *to, const char *from)
+static size_t cleanup_dirname(char *to, const char *from)
 {
-  register size_t length;
-  register char * pos;
-  register const char * from_ptr;
-  register char * start;
+  size_t length;
+  char * pos;
+  const char * from_ptr;
+  char * start;
   char parent[5],				/* for "FN_PARENTDIR" */
        buff[FN_REFLEN+1],*end_parentdir;
 

=== modified file 'drizzled/internal/mf_qsort.cc'
--- drizzled/internal/mf_qsort.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/mf_qsort.cc	2011-02-21 21:45:55 +0000
@@ -41,13 +41,13 @@
 do {							\
    if (swap_ptrs)					\
    {							\
-     register char **a = (char**) (A), **b = (char**) (B);  \
+     char **a = (char**) (A), **b = (char**) (B);  \
      char *tmp = *a; *a++ = *b; *b++ = tmp;		\
    }							\
    else							\
    {							\
-     register char *a = (A), *b = (B);			\
-     register char *end= a+size;				\
+     char *a = (A), *b = (B);			\
+     char *end= a+size;				\
      do							\
      {							\
        char tmp = *a; *a++ = *b; *b++ = tmp;		\

=== modified file 'drizzled/internal/my_sys.h'
--- drizzled/internal/my_sys.h	2011-02-17 00:14:13 +0000
+++ drizzled/internal/my_sys.h	2011-02-22 06:09:35 +0000
@@ -269,12 +269,7 @@
 typedef int (*Process_option_func)(void *ctx, const char *group_name,
                                    const char *option);
 
-int handle_default_option(void *in_ctx, const char *group_name,
-                          const char *option);
-
-
-
-	/* Prototypes for mysys and my_func functions */
+/* Prototypes for mysys and my_func functions */
 
 extern int my_copy(const char *from,const char *to,myf MyFlags);
 DRIZZLED_API int my_delete(const char *name,myf MyFlags);

=== modified file 'drizzled/internal/ptr_cmp.cc' (properties changed: +x to -x)
--- drizzled/internal/ptr_cmp.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/ptr_cmp.cc	2011-02-21 21:45:55 +0000
@@ -62,8 +62,8 @@
 
 static int ptr_compare(size_t *compare_length, unsigned char **a, unsigned char **b)
 {
-  register int length= *compare_length;
-  register unsigned char *first,*last;
+  int length= *compare_length;
+  unsigned char *first,*last;
 
   first= *a; last= *b;
   while (--length)
@@ -77,8 +77,8 @@
 
 static int ptr_compare_0(size_t *compare_length,unsigned char **a, unsigned char **b)
 {
-  register int length= *compare_length;
-  register unsigned char *first,*last;
+  int length= *compare_length;
+  unsigned char *first,*last;
 
   first= *a; last= *b;
  loop:
@@ -98,8 +98,8 @@
 
 static int ptr_compare_1(size_t *compare_length,unsigned char **a, unsigned char **b)
 {
-  register int length= *compare_length-1;
-  register unsigned char *first,*last;
+  int length= *compare_length-1;
+  unsigned char *first,*last;
 
   first= *a+1; last= *b+1;
   cmp(-1);
@@ -119,8 +119,8 @@
 
 static int ptr_compare_2(size_t *compare_length,unsigned char **a, unsigned char **b)
 {
-  register int length= *compare_length-2;
-  register unsigned char *first,*last;
+  int length= *compare_length-2;
+  unsigned char *first,*last;
 
   first= *a +2 ; last= *b +2;
   cmp(-2);
@@ -141,8 +141,8 @@
 
 static int ptr_compare_3(size_t *compare_length,unsigned char **a, unsigned char **b)
 {
-  register int length= *compare_length-3;
-  register unsigned char *first,*last;
+  int length= *compare_length-3;
+  unsigned char *first,*last;
 
   first= *a +3 ; last= *b +3;
   cmp(-3);

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2011-02-17 00:14:13 +0000
+++ drizzled/item.h	2011-02-22 02:50:14 +0000
@@ -22,12 +22,12 @@
 #ifndef DRIZZLED_ITEM_H
 #define DRIZZLED_ITEM_H
 
+#include <drizzled/dtcollation.h>
 #include <drizzled/global_charset_info.h>
-#include <drizzled/dtcollation.h>
+#include <drizzled/item_result.h>
+#include <drizzled/memory/sql_alloc.h>
 #include <drizzled/sql_list.h>
 #include <drizzled/sql_string.h>
-#include <drizzled/memory/sql_alloc.h>
-#include <drizzled/item_result.h>
 
 #include <drizzled/visibility.h>
 

=== modified file 'drizzled/item/cmpfunc.cc'
--- drizzled/item/cmpfunc.cc	2011-02-21 18:33:47 +0000
+++ drizzled/item/cmpfunc.cc	2011-02-22 04:11:07 +0000
@@ -3886,7 +3886,7 @@
 
 void Item_cond::copy_andor_arguments(Session *session, Item_cond *item)
 {
-  List<Item>::iterator li(item->list);
+  List<Item>::iterator li(item->list.begin());
   while (Item *it= li++)
     list.push_back(it->copy_andor_structure(session));
 }
@@ -3896,7 +3896,7 @@
 Item_cond::fix_fields(Session *session, Item **)
 {
   assert(fixed == 0);
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   void *orig_session_marker= session->session_marker;
   unsigned char buff[sizeof(char*)];			// Max local vars in function
@@ -3972,7 +3972,7 @@
 
 void Item_cond::fix_after_pullout(Select_Lex *new_parent, Item **)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
 
   used_tables_cache=0;
@@ -4004,7 +4004,7 @@
 
 bool Item_cond::walk(Item_processor processor, bool walk_subquery, unsigned char *arg)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   while ((item= li++))
     if (item->walk(processor, walk_subquery, arg))
@@ -4033,7 +4033,7 @@
 
 Item *Item_cond::transform(Item_transformer transformer, unsigned char *arg)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   while ((item= li++))
   {
@@ -4084,7 +4084,7 @@
   if (!(this->*analyzer)(arg_p))
     return 0;
 
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   while ((item= li++))
   {
@@ -4103,7 +4103,7 @@
 void Item_cond::traverse_cond(Cond_traverser traverser,
                               void *arg, traverse_order order)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
 
   switch (order) {
@@ -4144,7 +4144,7 @@
 void Item_cond::split_sum_func(Session *session, Item **ref_pointer_array,
                                List<Item> &fields)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   while ((item= li++))
     item->split_sum_func(session, ref_pointer_array,
@@ -4161,7 +4161,7 @@
 
 void Item_cond::update_used_tables()
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
 
   used_tables_cache=0;
@@ -4178,7 +4178,7 @@
 void Item_cond::print(String *str, enum_query_type query_type)
 {
   str->append('(');
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   if ((item=li++))
     item->print(str, query_type);
@@ -4195,7 +4195,7 @@
 
 void Item_cond::neg_arguments(Session *session)
 {
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   while ((item= li++))		/* Apply not transformation to the arguments */
   {
@@ -4233,7 +4233,7 @@
 int64_t Item_cond_and::val_int()
 {
   assert(fixed == 1);
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   null_value= 0;
   while ((item=li++))
@@ -4251,7 +4251,7 @@
 int64_t Item_cond_or::val_int()
 {
   assert(fixed == 1);
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   null_value=0;
   while ((item=li++))
@@ -4651,8 +4651,8 @@
 
 bool Item_func_like::turboBM_matches(const char* text, int text_len) const
 {
-  register int bcShift;
-  register int turboShift;
+  int bcShift;
+  int turboShift;
   int shift = pattern_len;
   int j     = 0;
   int u     = 0;
@@ -4666,7 +4666,7 @@
   {
     while (j <= tlmpl)
     {
-      register int i= plm1;
+      int i= plm1;
       while (i >= 0 && pattern[i] == text[i + j])
       {
 	i--;
@@ -4676,7 +4676,7 @@
       if (i < 0)
 	return 1;
 
-      register const int v = plm1 - i;
+      const int v = plm1 - i;
       turboShift = u - v;
       bcShift    = bmBc[(uint32_t) (unsigned char) text[i + j]] - plm1 + i;
       shift      = (turboShift > bcShift) ? turboShift : bcShift;
@@ -4697,7 +4697,7 @@
   {
     while (j <= tlmpl)
     {
-      register int i = plm1;
+      int i = plm1;
       while (i >= 0 && likeconv(cs,pattern[i]) == likeconv(cs,text[i + j]))
       {
         i--;
@@ -4708,7 +4708,7 @@
       if (i < 0)
         return 1;
 
-      register const int v= plm1 - i;
+      const int v= plm1 - i;
       turboShift= u - v;
       bcShift= bmBc[(uint32_t) likeconv(cs, text[i + j])] - plm1 + i;
       shift= (turboShift > bcShift) ? turboShift : bcShift;
@@ -4749,7 +4749,7 @@
 int64_t Item_cond_xor::val_int()
 {
   assert(fixed == 1);
-  List<Item>::iterator li(list);
+  List<Item>::iterator li(list.begin());
   Item *item;
   int result=0;
   null_value=0;
@@ -4929,7 +4929,7 @@
   : item::function::Boolean(), eval_item(0), cond_false(0)
 {
   const_item_cache= false;
-  List<Item_field>::iterator li(item_equal->fields);
+  List<Item_field>::iterator li(item_equal->fields.begin());
   Item_field *item;
   while ((item= li++))
   {
@@ -4981,7 +4981,7 @@
 
 bool Item_equal::contains(Field *field)
 {
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item_field *item;
   while ((item= it++))
   {
@@ -5040,7 +5040,7 @@
 void Item_equal::sort(Item_field_cmpfunc cmp, void *arg)
 {
   bool swap;
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   do
   {
     Item_field *item1= it++;
@@ -5081,7 +5081,7 @@
 
 void Item_equal::update_const()
 {
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item *item;
   while ((item= it++))
   {
@@ -5095,7 +5095,7 @@
 
 bool Item_equal::fix_fields(Session *, Item **)
 {
-  List<Item_field>::iterator li(fields);
+  List<Item_field>::iterator li(fields.begin());
   Item *item;
   not_null_tables_cache= used_tables_cache= 0;
   const_item_cache= false;
@@ -5115,7 +5115,7 @@
 
 void Item_equal::update_used_tables()
 {
-  List<Item_field>::iterator li(fields);
+  List<Item_field>::iterator li(fields.begin());
   Item *item;
   not_null_tables_cache= used_tables_cache= 0;
   if ((const_item_cache= cond_false))
@@ -5133,7 +5133,7 @@
   Item_field *item_field;
   if (cond_false)
     return 0;
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item *item= const_item ? const_item : it++;
   eval_item->store_value(item);
   if ((null_value= item->null_value))
@@ -5159,7 +5159,7 @@
 
 bool Item_equal::walk(Item_processor processor, bool walk_subquery, unsigned char *arg)
 {
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item *item;
   while ((item= it++))
   {
@@ -5171,7 +5171,7 @@
 
 Item *Item_equal::transform(Item_transformer transformer, unsigned char *arg)
 {
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item *item;
   while ((item= it++))
   {
@@ -5195,7 +5195,7 @@
 {
   str->append(func_name());
   str->append('(');
-  List<Item_field>::iterator it(fields);
+  List<Item_field>::iterator it(fields.begin());
   Item *item;
   if (const_item)
     const_item->print(str, query_type);

=== modified file 'drizzled/item/cmpfunc.h'
--- drizzled/item/cmpfunc.h	2011-02-20 00:09:56 +0000
+++ drizzled/item/cmpfunc.h	2011-02-21 23:34:19 +0000
@@ -1540,14 +1540,10 @@
 
 class Item_equal: public item::function::Boolean
 {
-  List<Item_field> fields; /* list of equal field items                    */
-  Item *const_item;        /* optional constant item equal to fields items */
-  cmp_item *eval_item;
-  bool cond_false;
+public:
+  typedef List<Item_field> fields_t;
 
-public:
-  inline Item_equal() :
-    item::function::Boolean(),
+  Item_equal() :
     const_item(0),
     eval_item(0),
     cond_false(0)
@@ -1555,6 +1551,11 @@
     const_item_cache=0;
   }
 
+  fields_t::iterator begin()
+  {
+    return fields.begin();
+  }
+
   Item_equal(Item_field *f1, Item_field *f2);
   Item_equal(Item *c, Item_field *f);
   Item_equal(Item_equal *item_equal);
@@ -1580,6 +1581,12 @@
   virtual void print(String *str, enum_query_type query_type);
   const CHARSET_INFO *compare_collation()
   { return fields.head()->collation.collation; }
+private:
+  fields_t fields; /* list of equal field items                    */
+  Item *const_item;        /* optional constant item equal to fields items */
+  cmp_item *eval_item;
+  bool cond_false;
+
 };
 
 class COND_EQUAL: public memory::SqlAlloc
@@ -1601,7 +1608,7 @@
 {
 public:
   inline Item_equal_iterator(Item_equal &item_equal)
-    :List<Item_field>::iterator (item_equal.fields)
+    :List<Item_field>::iterator (item_equal.fields.begin() )
   {}
   inline Item_field* operator++(int)
   {

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2011-02-18 12:05:58 +0000
+++ drizzled/item/create.cc	2011-02-21 22:42:56 +0000
@@ -1053,7 +1053,7 @@
   if (params)
   {
     Item *param;
-    List<Item>::iterator it(*params);
+    List<Item>::iterator it(params->begin());
     while ((param= it++))
     {
       if (! param->is_autogenerated_name)

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2011-02-21 18:33:47 +0000
+++ drizzled/item/field.cc	2011-02-22 00:55:58 +0000
@@ -56,7 +56,7 @@
 bool Item_field::collect_item_field_processor(unsigned char *arg)
 {
   List<Item_field> *item_list= (List<Item_field>*) arg;
-  List<Item_field>::iterator item_list_it(*item_list);
+  List<Item_field>::iterator item_list_it(item_list->begin());
   Item_field *curr_item;
   while ((curr_item= item_list_it++))
   {
@@ -980,7 +980,7 @@
   Item_equal *item= 0;
   while (cond_equal)
   {
-    List<Item_equal>::iterator li(cond_equal->current_level);
+    List<Item_equal>::iterator li(cond_equal->current_level.begin());
     while ((item= li++))
     {
       if (item->contains(field))

=== modified file 'drizzled/item/row.cc'
--- drizzled/item/row.cc	2011-02-18 12:05:58 +0000
+++ drizzled/item/row.cc	2011-02-21 22:42:56 +0000
@@ -45,7 +45,7 @@
     items= (Item**) memory::sql_alloc(sizeof(Item*)*arg_count);
   else
     items= 0;
-  List<Item>::iterator li(arg);
+  List<Item>::iterator li(arg.begin());
   uint32_t i= 0;
   Item *item;
   while ((item= li++))

=== modified file 'drizzled/item/subselect.cc'
--- drizzled/item/subselect.cc	2011-02-21 18:33:47 +0000
+++ drizzled/item/subselect.cc	2011-02-22 00:55:58 +0000
@@ -273,7 +273,7 @@
   {
     for (Select_Lex *lex= unit->first_select(); lex; lex= lex->next_select())
     {
-      List<Item>::iterator li(lex->item_list);
+      List<Item>::iterator li(lex->item_list.begin());
       Item *item;
       Order *order;
 
@@ -1057,7 +1057,7 @@
         upper_item->set_sum_test(item);
       *select_lex->ref_pointer_array= item;
       {
-	List<Item>::iterator it(select_lex->item_list);
+	List<Item>::iterator it(select_lex->item_list.begin());
 	it++;
 	it.replace(item);
       }
@@ -2096,7 +2096,7 @@
 void subselect_engine::set_row(List<Item> &item_list, Item_cache **row)
 {
   Item *sel_item;
-  List<Item>::iterator li(item_list);
+  List<Item>::iterator li(item_list.begin());
   res_type= STRING_RESULT;
   res_field_type= DRIZZLE_TYPE_VARCHAR;
   for (uint32_t i= 0; (sel_item= li++); i++)

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2011-02-21 18:33:47 +0000
+++ drizzled/item/sum.cc	2011-02-22 00:55:58 +0000
@@ -256,7 +256,7 @@
         select the field belongs to. If there are some then an error is
         raised.
     */
-    List<Item_field>::iterator of(outer_fields);
+    List<Item_field>::iterator of(outer_fields.begin());
     while ((field= of++))
     {
       Select_Lex *sel= field->cached_table->select_lex;
@@ -387,7 +387,7 @@
   if ((args=(Item**) memory::sql_alloc(sizeof(Item*)*arg_count)))
   {
     uint32_t i=0;
-    List<Item>::iterator li(list);
+    List<Item>::iterator li(list.begin());
     Item *item;
 
     while ((item=li++))
@@ -2998,7 +2998,7 @@
   order= (Order**)(args + arg_count);
 
   /* fill args items of show and sort */
-  List<Item>::iterator li(*select_list);
+  List<Item>::iterator li(select_list->begin());
 
   for (arg_ptr=args ; (item_select= li++) ; arg_ptr++)
     *arg_ptr= item_select;

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2011-02-21 19:38:54 +0000
+++ drizzled/join.cc	2011-02-22 00:55:58 +0000
@@ -2213,7 +2213,7 @@
                               bool before_group_by, 
                               bool recompute)
 {
-  List<Item>::iterator it(field_list);
+  List<Item>::iterator it(field_list.begin());
   Item_sum **func;
   Item *item;
 
@@ -2294,7 +2294,7 @@
     }
   }
 
-  List<Item>::iterator it(all_fields);
+  List<Item>::iterator it(all_fields.begin());
   Item *item;
   while ((item= it++))
   {
@@ -2369,7 +2369,7 @@
 */
 bool Join::rollup_make_fields(List<Item> &fields_arg, List<Item> &sel_fields, Item_sum ***func)
 {
-  List<Item>::iterator it(fields_arg);
+  List<Item>::iterator it(fields_arg.begin());
   Item *first_field= sel_fields.head();
   uint32_t level;
 
@@ -2400,7 +2400,7 @@
     uint32_t pos= send_group_parts - level -1;
     bool real_fields= 0;
     Item *item;
-    List<Item>::iterator new_it(rollup.getFields()[pos]);
+    List<Item>::iterator new_it(rollup.getFields()[pos].begin());
     Item **ref_array_start= rollup.getRefPointerArrays()[pos];
     Order *start_group;
 
@@ -2549,7 +2549,7 @@
     {
       int write_error;
       Item *item;
-      List<Item>::iterator it(rollup.getFields()[i]);
+      List<Item>::iterator it(rollup.getFields()[i].begin());
       while ((item= it++))
       {
         if (item->type() == Item::NULL_ITEM && item->is_result_field())
@@ -5292,7 +5292,7 @@
   {
     if (send_row)
     {
-      List<Item>::iterator it(fields);
+      List<Item>::iterator it(fields.begin());
       Item *item;
       while ((item= it++))
         item->no_rows_in_result();
@@ -5430,7 +5430,7 @@
   TableList *table;
   NestedJoin *nested_join;
   TableList *prev_table= 0;
-  List<TableList>::iterator li(*join_list);
+  List<TableList>::iterator li(join_list->begin());
 
   /*
     Try to simplify join operations from join_list.
@@ -5573,7 +5573,7 @@
     if (nested_join && !table->on_expr)
     {
       TableList *tbl;
-      List<TableList>::iterator it(nested_join->join_list);
+      List<TableList>::iterator it(nested_join->join_list.begin());
       while ((tbl= it++))
       {
         tbl->setEmbedding(table->getEmbedding());
@@ -5596,7 +5596,7 @@
 
   /* Calculate how many saved fields there is in list */
   field_count=0;
-  List<Item>::iterator it(fields);
+  List<Item>::iterator it(fields.begin());
   Item *item;
   while ((item=it++))
   {
@@ -6138,7 +6138,7 @@
 */
 static uint32_t build_bitmap_for_nested_joins(List<TableList> *join_list, uint32_t first_unused)
 {
-  List<TableList>::iterator li(*join_list);
+  List<TableList>::iterator li(join_list->begin());
   TableList *table;
   while ((table= li++))
   {
@@ -6209,7 +6209,7 @@
 */
 static void reset_nj_counters(List<TableList> *join_list)
 {
-  List<TableList>::iterator li(*join_list);
+  List<TableList>::iterator li(join_list->begin());
   TableList *table;
   while ((table= li++))
   {

=== modified file 'drizzled/optimizer/key_field.cc'
--- drizzled/optimizer/key_field.cc	2011-02-20 00:09:56 +0000
+++ drizzled/optimizer/key_field.cc	2011-02-21 23:34:19 +0000
@@ -77,8 +77,8 @@
                                       uint32_t *and_level,
                                       vector<optimizer::SargableParam> &sargables)
 {
-  List<TableList>::iterator li(nested_join_table->getNestedJoin()->join_list);
-  List<TableList>::iterator li2(nested_join_table->getNestedJoin()->join_list);
+  List<TableList>::iterator li(nested_join_table->getNestedJoin()->join_list.begin());
+  List<TableList>::iterator li2(nested_join_table->getNestedJoin()->join_list.begin());
   bool have_another= false;
   table_map tables= 0;
   TableList *table;
@@ -94,7 +94,7 @@
         /* It's a semi-join nest. Walk into it as if it wasn't a nest */
         have_another= true;
         li2= li;
-        li= List<TableList>::iterator(table->getNestedJoin()->join_list);
+        li= List<TableList>::iterator(table->getNestedJoin()->join_list.begin());
       }
       else
         add_key_fields_for_nj(join, table, end, and_level, sargables);
@@ -425,7 +425,7 @@
 {
   if (cond->type() == Item_func::COND_ITEM)
   {
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     optimizer::KeyField *org_key_fields= *key_fields;
 
     if (((Item_cond*) cond)->functype() == Item_func::COND_AND_FUNC)

=== modified file 'drizzled/optimizer/quick_group_min_max_select.cc'
--- drizzled/optimizer/quick_group_min_max_select.cc	2011-02-19 23:05:57 +0000
+++ drizzled/optimizer/quick_group_min_max_select.cc	2011-02-21 23:34:19 +0000
@@ -150,13 +150,13 @@
 
     if (have_min)
     {
-      if (! (min_functions_it= new List<Item_sum>::iterator(*min_functions)))
+      if (! (min_functions_it= new List<Item_sum>::iterator(min_functions->begin())))
         return 1;
     }
 
     if (have_max)
     {
-      if (! (max_functions_it= new List<Item_sum>::iterator(*max_functions)))
+      if (! (max_functions_it= new List<Item_sum>::iterator(max_functions->begin())))
         return 1;
     }
   }

=== modified file 'drizzled/optimizer/range.cc'
--- drizzled/optimizer/range.cc	2011-02-21 18:33:47 +0000
+++ drizzled/optimizer/range.cc	2011-02-22 00:55:58 +0000
@@ -840,7 +840,7 @@
         optimizer::SEL_IMERGE *imerge= NULL;
         optimizer::TableReadPlan *best_conj_trp= NULL;
         optimizer::TableReadPlan *new_conj_trp= NULL;
-        List<optimizer::SEL_IMERGE>::iterator it(tree->merges);
+        List<optimizer::SEL_IMERGE>::iterator it(tree->merges.begin());
         while ((imerge= it++))
         {
           new_conj_trp= get_best_disjunct_quick(session, &param, imerge, best_read_time);
@@ -2565,7 +2565,7 @@
 
   if (cond->type() == Item::COND_ITEM)
   {
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
 
     if (((Item_cond*) cond)->functype() == Item_func::COND_AND_FUNC)
     {
@@ -4599,7 +4599,7 @@
     return NULL;
 
   /* Analyze the query in more detail. */
-  List<Item>::iterator select_items_it(join->fields_list);
+  List<Item>::iterator select_items_it(join->fields_list.begin());
 
   /* Check (SA1,SA4) and store the only MIN/MAX argument - the C attribute.*/
   if (join->make_sum_func_list(join->all_fields, join->fields_list, 1))
@@ -5036,7 +5036,7 @@
   Item::Type cond_type= cond->type();
   if (cond_type == Item::COND_ITEM) /* 'AND' or 'OR' */
   {
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *and_or_arg= NULL;
     while ((and_or_arg= li++))
     {

=== modified file 'drizzled/optimizer/sel_tree.cc'
--- drizzled/optimizer/sel_tree.cc	2011-02-18 10:22:24 +0000
+++ drizzled/optimizer/sel_tree.cc	2011-02-21 23:34:19 +0000
@@ -112,7 +112,7 @@
                                optimizer::SEL_TREE *tree)
 {
   optimizer::SEL_IMERGE *imerge= NULL;
-  List_iterator<optimizer::SEL_IMERGE> it(*im1);
+  List_iterator<optimizer::SEL_IMERGE> it(im1->begin());
   while ((imerge= it++))
   {
     if (imerge->or_sel_tree_with_checks(param, tree))

=== modified file 'drizzled/optimizer/sum.cc'
--- drizzled/optimizer/sum.cc	2011-02-20 00:09:56 +0000
+++ drizzled/optimizer/sum.cc	2011-02-21 23:34:19 +0000
@@ -114,7 +114,7 @@
 
 int optimizer::sum_query(TableList *tables, List<Item> &all_fields, COND *conds)
 {
-  List<Item>::iterator it(all_fields);
+  List<Item>::iterator it(all_fields.begin());
   int const_result= 1;
   bool recalc_const_item= false;
   uint64_t count= 1;
@@ -689,7 +689,7 @@
     }
 
     /* AND */
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *item;
     while ((item= li++))
     {
@@ -1071,7 +1071,7 @@
   /* If AND/OR condition */
   if (cond->type() == Item::COND_ITEM)
   {
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *item;
     while ((item= li++))
     {

=== modified file 'drizzled/select_dumpvar.cc'
--- drizzled/select_dumpvar.cc	2011-02-18 11:56:54 +0000
+++ drizzled/select_dumpvar.cc	2011-02-21 23:34:19 +0000
@@ -29,7 +29,7 @@
 {
   std::vector<var *>::const_iterator iter= var_list.begin();
 
-  List<Item>::iterator it(items);
+  List<Item>::iterator it(items.begin());
   Item *item= NULL;
   var *current_var;
 

=== modified file 'drizzled/select_exists_subselect.h'
--- drizzled/select_exists_subselect.h	2010-12-18 04:43:40 +0000
+++ drizzled/select_exists_subselect.h	2011-02-22 02:50:14 +0000
@@ -21,6 +21,8 @@
 #ifndef DRIZZLED_SELECT_EXISTS_SUBSELECT_H
 #define DRIZZLED_SELECT_EXISTS_SUBSELECT_H
 
+#include <drizzled/select_subselect.h>
+
 namespace drizzled
 {
 

=== modified file 'drizzled/select_send.h'
--- drizzled/select_send.h	2011-02-19 23:46:11 +0000
+++ drizzled/select_send.h	2011-02-21 23:34:19 +0000
@@ -100,7 +100,7 @@
     */
     plugin::TransactionalStorageEngine::releaseTemporaryLatches(session);
 
-    List<Item>::iterator li(items);
+    List<Item>::iterator li(items.begin());
     char buff[MAX_FIELD_WIDTH];
     String buffer(buff, sizeof(buff), &my_charset_bin);
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-02-19 23:46:11 +0000
+++ drizzled/session.cc	2011-02-22 04:11:07 +0000
@@ -24,56 +24,49 @@
 #include <config.h>
 
 #include <drizzled/copy_field.h>
-#include <drizzled/session.h>
-#include <drizzled/session/cache.h>
+#include <drizzled/data_home.h>
+#include <drizzled/display.h>
+#include <drizzled/drizzled.h>
 #include <drizzled/error.h>
 #include <drizzled/gettext.h>
-#include <drizzled/query_id.h>
-#include <drizzled/data_home.h>
-#include <drizzled/sql_base.h>
-#include <drizzled/lock.h>
+#include <drizzled/identifier.h>
+#include <drizzled/internal/iocache.h>
+#include <drizzled/internal/thread_var.h>
+#include <drizzled/internal_error_handler.h>
 #include <drizzled/item/cache.h>
+#include <drizzled/item/empty_string.h>
 #include <drizzled/item/float.h>
 #include <drizzled/item/return_int.h>
-#include <drizzled/item/empty_string.h>
-#include <drizzled/show.h>
+#include <drizzled/lock.h>
+#include <drizzled/plugin/authentication.h>
 #include <drizzled/plugin/client.h>
+#include <drizzled/plugin/event_observer.h>
+#include <drizzled/plugin/logging.h>
+#include <drizzled/plugin/query_rewrite.h>
 #include <drizzled/plugin/scheduler.h>
-#include <drizzled/plugin/authentication.h>
-#include <drizzled/plugin/logging.h>
 #include <drizzled/plugin/transactional_storage_engine.h>
-#include <drizzled/plugin/query_rewrite.h>
 #include <drizzled/probes.h>
-#include <drizzled/table_proto.h>
 #include <drizzled/pthread_globals.h>
-#include <drizzled/transaction_services.h>
-#include <drizzled/drizzled.h>
-#include <drizzled/select_to_file.h>
+#include <drizzled/query_id.h>
+#include <drizzled/refresh_version.h>
+#include <drizzled/select_dump.h>
+#include <drizzled/select_exists_subselect.h>
 #include <drizzled/select_export.h>
-#include <drizzled/select_dump.h>
+#include <drizzled/select_max_min_finder_subselect.h>
+#include <drizzled/select_singlerow_subselect.h>
 #include <drizzled/select_subselect.h>
-#include <drizzled/select_singlerow_subselect.h>
-#include <drizzled/select_max_min_finder_subselect.h>
-#include <drizzled/select_exists_subselect.h>
+#include <drizzled/select_to_file.h>
+#include <drizzled/session.h>
+#include <drizzled/session/cache.h>
+#include <drizzled/show.h>
+#include <drizzled/sql_base.h>
+#include <drizzled/table/singular.h>
+#include <drizzled/table_proto.h>
 #include <drizzled/tmp_table_param.h>
-#include <drizzled/internal_error_handler.h>
-
-#include <drizzled/identifier.h>
-
-#include <drizzled/refresh_version.h>
-
-#include <drizzled/table/singular.h>
-
-#include <plugin/myisam/myisam.h>
-#include <drizzled/internal/iocache.h>
-#include <drizzled/internal/thread_var.h>
-#include <drizzled/plugin/event_observer.h>
-
+#include <drizzled/transaction_services.h>
 #include <drizzled/user_var_entry.h>
-
 #include <drizzled/util/functors.h>
-
-#include <drizzled/display.h>
+#include <plugin/myisam/myisam.h>
 
 #include <algorithm>
 #include <climits>
@@ -1097,7 +1090,7 @@
 
   /* Check if there is any blobs in data */
   {
-    List<Item>::iterator li(list);
+    List<Item>::iterator li(list.begin());
     Item *item;
     while ((item=li++))
     {
@@ -1162,7 +1155,7 @@
   row_count++;
   Item *item;
   uint32_t used_length=0,items_left=items.elements;
-  List<Item>::iterator li(items);
+  List<Item>::iterator li(items.begin());
 
   if (my_b_write(cache,(unsigned char*) exchange->line_start->ptr(),
                  exchange->line_start->length()))
@@ -1351,7 +1344,7 @@
 
 bool select_dump::send_data(List<Item> &items)
 {
-  List<Item>::iterator li(items);
+  List<Item>::iterator li(items.begin());
   char buff[MAX_FIELD_WIDTH];
   String tmp(buff,sizeof(buff),&my_charset_bin),*res;
   tmp.length(0);
@@ -1404,7 +1397,7 @@
     unit->offset_limit_cnt--;
     return(0);
   }
-  List<Item>::iterator li(items);
+  List<Item>::iterator li(items.begin());
   Item *val_item;
   for (uint32_t i= 0; (val_item= li++); i++)
     it->store(i, val_item);
@@ -1422,7 +1415,7 @@
 bool select_max_min_finder_subselect::send_data(List<Item> &items)
 {
   Item_maxmin_subselect *it= (Item_maxmin_subselect *)item;
-  List<Item>::iterator li(items);
+  List<Item>::iterator li(items.begin());
   Item *val_item= li++;
   it->register_value();
   if (it->assigned())

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2011-02-21 19:38:54 +0000
+++ drizzled/sql_base.cc	2011-02-22 00:55:58 +0000
@@ -1930,7 +1930,7 @@
                            bool, TableList **actual_table)
 {
   List<Natural_join_column>::iterator
-    field_it(*(table_ref->join_columns));
+    field_it(table_ref->join_columns->begin());
   Natural_join_column *nj_col, *curr_nj_col;
   Field *found_field;
 
@@ -2145,7 +2145,7 @@
     */
     if (table_name && table_name[0])
     {
-      List<TableList>::iterator it(table_list->getNestedJoin()->join_list);
+      List<TableList>::iterator it(table_list->getNestedJoin()->join_list.begin());
       TableList *table;
       while ((table= it++))
       {
@@ -2444,7 +2444,7 @@
                   find_item_error_report_type report_error,
                   enum_resolution_type *resolution)
 {
-  List<Item>::iterator li(items);
+  List<Item>::iterator li(items.begin());
   Item **found=0, **found_unaliased= 0, *item;
   const char *db_name=0;
   const char *field_name=0;
@@ -2647,7 +2647,7 @@
 static bool
 test_if_string_in_list(const char *find, List<String> *str_list)
 {
-  List<String>::iterator str_list_it(*str_list);
+  List<String>::iterator str_list_it(str_list->begin());
   String *curr_str;
   size_t find_length= strlen(find);
   while ((curr_str= str_list_it++))
@@ -2981,12 +2981,12 @@
   if (using_fields && found_using_fields < using_fields->elements)
   {
     String *using_field_name;
-    List<String>::iterator using_fields_it(*using_fields);
+    List<String>::iterator using_fields_it(using_fields->begin());
     while ((using_field_name= using_fields_it++))
     {
       const char *using_field_name_ptr= using_field_name->c_ptr();
       List<Natural_join_column>::iterator
-        it(*(natural_using_join->join_columns));
+        it(natural_using_join->join_columns->begin());
       Natural_join_column *common_field;
 
       for (;;)
@@ -3068,7 +3068,7 @@
   /* Call the procedure recursively for each nested table reference. */
   if (table_ref->getNestedJoin())
   {
-    List<TableList>::iterator nested_it(table_ref->getNestedJoin()->join_list);
+    List<TableList>::iterator nested_it(table_ref->getNestedJoin()->join_list.begin());
     TableList *same_level_left_neighbor= nested_it++;
     TableList *same_level_right_neighbor= NULL;
     /* Left/right-most neighbors, possibly at higher levels in the join tree. */
@@ -3122,7 +3122,7 @@
   {
     assert(table_ref->getNestedJoin() &&
            table_ref->getNestedJoin()->join_list.elements == 2);
-    List<TableList>::iterator operand_it(table_ref->getNestedJoin()->join_list);
+    List<TableList>::iterator operand_it(table_ref->getNestedJoin()->join_list.begin());
     /*
       Notice that the order of join operands depends on whether table_ref
       represents a LEFT or a RIGHT join. In a RIGHT join, the operands are
@@ -3222,7 +3222,7 @@
   if (from_clause->elements == 0)
     return false; /* We come here in the case of UNIONs. */
 
-  List<TableList>::iterator table_ref_it(*from_clause);
+  List<TableList>::iterator table_ref_it(from_clause->begin());
   TableList *table_ref; /* Current table reference. */
   /* Table reference to the left of the current. */
   TableList *left_neighbor;
@@ -3272,7 +3272,7 @@
     return 0;
 
   Item *item;
-  List<Item>::iterator it(fields);
+  List<Item>::iterator it(fields.begin());
 
   session->getLex()->current_select->cur_pos_in_select_list= 0;
   while (wild_num && (item= it++))
@@ -3333,7 +3333,7 @@
   register Item *item;
   enum_mark_columns save_mark_used_columns= session->mark_used_columns;
   nesting_map save_allow_sum_func= session->getLex()->allow_sum_func;
-  List<Item>::iterator it(fields);
+  List<Item>::iterator it(fields.begin());
   bool save_is_item_list_lookup;
 
   session->mark_used_columns= mark_used_columns;
@@ -3805,7 +3805,8 @@
 bool
 fill_record(Session *session, List<Item> &fields, List<Item> &values, bool ignore_errors)
 {
-  List<Item>::iterator f(fields),v(values);
+  List<Item>::iterator f(fields.begin());
+  List<Item>::iterator v(values.begin());
   Item *value;
   Item_field *field;
   Table *table;
@@ -3870,7 +3871,7 @@
 
 bool fill_record(Session *session, Field **ptr, List<Item> &values, bool)
 {
-  List<Item>::iterator v(values);
+  List<Item>::iterator v(values.begin());
   Item *value;
   Table *table= 0;
   Field *field;

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2011-02-18 11:56:54 +0000
+++ drizzled/sql_base.h	2011-02-22 06:09:35 +0000
@@ -155,6 +155,8 @@
                             db_name, table_name);
 }
 
+bool drizzle_rm_tmp_tables();
+
 } /* namespace drizzled */
 
 #endif /* DRIZZLED_SQL_BASE_H */

=== modified file 'drizzled/sql_error.cc'
--- drizzled/sql_error.cc	2011-02-21 18:33:47 +0000
+++ drizzled/sql_error.cc	2011-02-22 00:55:58 +0000
@@ -227,7 +227,7 @@
 
   unit->set_limit(sel);
 
-  List<DRIZZLE_ERROR>::iterator it(session->warn_list);
+  List<DRIZZLE_ERROR>::iterator it(session->warn_list.begin());
   while ((err= it++))
   {
     /* Skip levels that the user is not interested in */

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2011-02-21 19:38:54 +0000
+++ drizzled/sql_insert.cc	2011-02-22 00:55:58 +0000
@@ -245,7 +245,7 @@
   uint64_t id;
   CopyInfo info;
   Table *table= 0;
-  List<List_item>::iterator its(values_list);
+  List<List_item>::iterator its(values_list.begin());
   List_item *values;
   Name_resolution_context *context;
   Name_resolution_context_state ctx_state;
@@ -1153,7 +1153,7 @@
         order to get correct values from those fields when the select
         employs a temporary table.
       */
-      List<Item>::iterator li(*info.update_values);
+      List<Item>::iterator li(info.update_values->begin());
       Item *item;
 
       while ((item= li++))
@@ -1493,7 +1493,7 @@
   TableShare share(message::Table::INTERNAL);
   uint32_t select_field_count= items->elements;
   /* Add selected items to field list */
-  List<Item>::iterator it(*items);
+  List<Item>::iterator it(items->begin());
   Item *item;
   Field *tmp_field;
 

=== modified file 'drizzled/sql_list.h'
--- drizzled/sql_list.h	2011-02-20 17:59:04 +0000
+++ drizzled/sql_list.h	2011-02-22 00:51:13 +0000
@@ -302,15 +302,9 @@
     :list(0), el(0), prev(0), current(0)
   {}
 
-  base_list_iterator(base_list &list_par)
-  { init(list_par); }
-
-  inline void init(base_list &list_par)
+  base_list_iterator(base_list &list_par, list_node** el0)
+    :list(&list_par), el(el0), prev(0), current(0)
   {
-    list= &list_par;
-    el= &list_par.first;
-    prev= 0;
-    current= 0;
   }
 
   inline void *next(void)
@@ -370,6 +364,8 @@
 public:
   typedef List_iterator<T> iterator;
 
+  friend class List_iterator<T>;
+
   inline List() :base_list() {}
   inline List(const List<T> &tmp) :base_list(tmp) {}
   inline List(const List<T> &tmp, memory::Root *mem_root) :
@@ -396,7 +392,7 @@
 
   iterator begin()
   {
-    return iterator(*this);
+    return iterator(*this, &first);
   }
 };
 
@@ -404,8 +400,8 @@
 template <class T> class List_iterator :public base_list_iterator
 {
 public:
-  explicit List_iterator(List<T> &a) : base_list_iterator(a) {}
-  List_iterator() : base_list_iterator() {}
+  List_iterator(List<T>& a, list_node** b) : base_list_iterator(a, b) {};
+  List_iterator() {};
   inline T* operator++(int) { return (T*) base_list_iterator::next(); }
   inline T *replace(T *a)   { return (T*) base_list_iterator::replace(a); }
   inline T *replace(List<T> &a) { return (T*) base_list_iterator::replace(a); }
@@ -428,12 +424,10 @@
 */
 
 template <typename T>
-inline
-void
-list_copy_and_replace_each_value(List<T> &list, memory::Root *mem_root)
+void list_copy_and_replace_each_value(List<T> &list, memory::Root *mem_root)
 {
   /* Make a deep copy of each element */
-  typename List<T>::iterator it(list);
+  typename List<T>::iterator it(list.begin());
   T *el;
   while ((el= it++))
     it.replace(el->clone(mem_root));

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2011-02-21 19:38:54 +0000
+++ drizzled/sql_load.cc	2011-02-22 00:55:58 +0000
@@ -225,7 +225,7 @@
 
   size_t tot_length=0;
   bool use_blobs= 0, use_vars= 0;
-  List<Item>::iterator it(fields_vars);
+  List<Item>::iterator it(fields_vars.begin());
   Item *item;
 
   while ((item= it++))
@@ -431,7 +431,7 @@
                   List<Item> &set_values, READ_INFO &read_info,
                   uint32_t skip_lines, bool ignore_check_option_errors)
 {
-  List<Item>::iterator it(fields_vars);
+  List<Item>::iterator it(fields_vars.begin());
   Item_field *sql_field;
   Table *table= table_list->table;
   uint64_t id;
@@ -552,7 +552,7 @@
 	       String &enclosed, uint32_t skip_lines,
 	       bool ignore_check_option_errors)
 {
-  List<Item>::iterator it(fields_vars);
+  List<Item>::iterator it(fields_vars.begin());
   Item *item;
   Table *table= table_list->table;
   uint32_t enclosed_length;

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2011-02-21 19:38:54 +0000
+++ drizzled/sql_select.cc	2011-02-22 05:11:40 +0000
@@ -212,14 +212,14 @@
   bool res= false;
   bool direct_ref= false;
 
-  List<Item_outer_ref>::iterator ref_it(select->inner_refs_list);
+  List<Item_outer_ref>::iterator ref_it(select->inner_refs_list.begin());
   while ((ref= ref_it++))
   {
     Item *item= ref->outer_ref;
     Item **item_ref= ref->ref;
     Item_ref *new_ref;
     /*
-      TODO: this field item already might be present in the select list.
+      @todo this field item already might be present in the select list.
       In this case instead of adding new field item we could use an
       existing one. The change will lead to less operations for copying fields,
       smaller temporary tables and less data passed through filesort.
@@ -618,7 +618,7 @@
 
   /* Process ON conditions for the nested joins */
   {
-    List<TableList>::iterator li(*join_tab->join->join_list);
+    List<TableList>::iterator li(join_tab->join->join_list->begin());
     TableList *table;
     while ((table= li++))
     {
@@ -752,7 +752,7 @@
 void add_group_and_distinct_keys(Join *join, JoinTable *join_tab)
 {
   List<Item_field> indexed_fields;
-  List<Item_field>::iterator indexed_fields_it(indexed_fields);
+  List<Item_field>::iterator indexed_fields_it(indexed_fields.begin());
   Order      *cur_group;
   Item_field *cur_item;
   key_map possible_keys(0);
@@ -766,7 +766,7 @@
   else if (join->select_distinct)
   { /* Collect all query fields referenced in the SELECT clause. */
     List<Item> &select_items= join->fields_list;
-    List<Item>::iterator select_items_it(select_items);
+    List<Item>::iterator select_items_it(select_items.begin());
     Item *item;
     while ((item= select_items_it++))
       item->walk(&Item::collect_item_field_processor, 0,
@@ -1352,7 +1352,7 @@
   bool in_upper_level= false;
   while (cond_equal)
   {
-    List<Item_equal>::iterator li(cond_equal->current_level);
+    List<Item_equal>::iterator li(cond_equal->current_level.begin());
     while ((item= li++))
     {
       if (item->contains(field))
@@ -1517,7 +1517,7 @@
         /* Merge two multiple equalities forming a new one */
         left_item_equal->merge(right_item_equal);
         /* Remove the merged multiple equality from the list */
-        List<Item_equal>::iterator li(cond_equal->current_level);
+        List<Item_equal>::iterator li(cond_equal->current_level.begin());
         while ((li++) != right_item_equal) {};
         li.remove();
       }
@@ -1806,7 +1806,7 @@
       Item_func::COND_AND_FUNC;
     List<Item> *args= ((Item_cond*) cond)->argument_list();
 
-    List<Item>::iterator li(*args);
+    List<Item>::iterator li(args->begin());
     Item *item;
 
     if (and_level)
@@ -1828,7 +1828,7 @@
           li.remove();
       }
 
-      List<Item_equal>::iterator it(cond_equal.current_level);
+      List<Item_equal>::iterator it(cond_equal.current_level.begin());
       while ((item_equal= it++))
       {
         item_equal->fix_length_and_dec();
@@ -1905,7 +1905,7 @@
         Item_cond_and *and_cond= new Item_cond_and(eq_list);
         and_cond->quick_fix_field();
         List<Item> *args= and_cond->argument_list();
-        List<Item_equal>::iterator it(cond_equal.current_level);
+        List<Item_equal>::iterator it(cond_equal.current_level.begin());
         while ((item_equal= it++))
         {
           item_equal->fix_length_and_dec();
@@ -2031,7 +2031,7 @@
   if (join_list)
   {
     TableList *table;
-    List<TableList>::iterator li(*join_list);
+    List<TableList>::iterator li(join_list->begin());
 
     while ((table= li++))
     {
@@ -2246,14 +2246,14 @@
       cond_equal= &((Item_cond_and *) cond)->cond_equal;
       cond_list->disjoin((List<Item> *) &cond_equal->current_level);
 
-      List<Item_equal>::iterator it(cond_equal->current_level);
+      List<Item_equal>::iterator it(cond_equal->current_level.begin());
       while ((item_equal= it++))
       {
         item_equal->sort(&compare_fields_by_table_order, table_join_idx);
       }
     }
 
-    List<Item>::iterator li(*cond_list);
+    List<Item>::iterator li(cond_list->begin());
     Item *item;
     while ((item= li++))
     {
@@ -2269,7 +2269,7 @@
 
     if (and_level)
     {
-      List<Item_equal>::iterator it(cond_equal->current_level);
+      List<Item_equal>::iterator it(cond_equal->current_level.begin());
       while ((item_equal= it++))
       {
         cond= eliminate_item_equal(cond, cond_equal->upper_levels, item_equal);
@@ -2319,7 +2319,7 @@
   if (cond->type() == Item::COND_ITEM)
   {
     List<Item> *cond_list= ((Item_cond*) cond)->argument_list();
-    List<Item>::iterator li(*cond_list);
+    List<Item>::iterator li(cond_list->begin());
     Item *item;
     while ((item= li++))
       update_const_equal_items(item, tab);
@@ -2377,7 +2377,7 @@
   if (cond->type() == Item::COND_ITEM)
   {
     bool and_level= ((Item_cond*) cond)->functype() == Item_func::COND_AND_FUNC;
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *item;
     while ((item=li++))
       change_cond_ref_to_const(session, save_list, and_level ? cond : item, item, field, value);
@@ -2457,7 +2457,7 @@
   if (conds->type() == Item::COND_ITEM)
   {
     Item_cond *cnd= (Item_cond*) conds;
-    List<Item>::iterator li(*(cnd->argument_list()));
+    List<Item>::iterator li(cnd->argument_list()->begin());
     Item *item;
     while ((item= li++))
     {
@@ -2481,7 +2481,7 @@
   if (cond->type() == Item::COND_ITEM)
   {
     bool and_level= ((Item_cond*) cond)->functype() == Item_func::COND_AND_FUNC;
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *item;
     list<COND_CMP> save;
     while ((item=li++))
@@ -2715,7 +2715,7 @@
   {
     bool and_level= (((Item_cond*) cond)->functype() == Item_func::COND_AND_FUNC);
 
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item::cond_result tmp_cond_value;
     bool should_fix_fields= false;
 
@@ -2847,7 +2847,7 @@
   }
   else if (cond->const_item() && !cond->is_expensive())
   /*
-    TODO:
+    @todo
     Excluding all expensive functions is too restritive we should exclude only
     materialized IN subquery predicates because they can't yet be evaluated
     here (they need additional initialization that is done later on).
@@ -2919,7 +2919,7 @@
   {
     bool and_level= (((Item_cond*) cond)->functype()
 		     == Item_func::COND_AND_FUNC);
-    List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+    List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
     Item *item;
     while ((item=li++))
     {
@@ -3449,7 +3449,7 @@
     }
   }
 
-  /* TODO: Why don't we do "Late NULLs Filtering" here? */
+  /* @todo Why don't we do "Late NULLs Filtering" here? */
   if (cmp_buffer_with_ref(tab) ||
       (table->status & (STATUS_GARBAGE | STATUS_NO_PARENT | STATUS_NULL_ROW)))
   {
@@ -3819,7 +3819,7 @@
         {
           if (!join->first_record)
           {
-                  List<Item>::iterator it(*join->fields);
+                  List<Item>::iterator it(join->fields->begin());
                   Item *item;
             /* No matching rows for group function */
             join->clear();
@@ -4058,7 +4058,7 @@
       Item_cond_and *new_cond=new Item_cond_and;
       if (!new_cond)
         return (COND*) 0;
-      List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+      List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
       Item *item;
       while ((item=li++))
       {
@@ -4088,7 +4088,7 @@
       Item_cond_or *new_cond=new Item_cond_or;
       if (!new_cond)
         return (COND*) 0;
-      List<Item>::iterator li(*((Item_cond*) cond)->argument_list());
+      List<Item>::iterator li(((Item_cond*) cond)->argument_list()->begin());
       Item *item;
       while ((item=li++))
       {
@@ -4440,7 +4440,7 @@
 {
   List<Item> *fields= (List<Item> *) data;
   bool part_found= 0;
-  List<Item>::iterator li(*fields);
+  List<Item>::iterator li(fields->begin());
   Item *item;
 
   while ((item= li++))
@@ -4525,7 +4525,7 @@
     save_quick= select->quick;
     /*
       assume results are not ordered when index merge is used
-      TODO: sergeyp: Results of all index merge selects actually are ordered
+      @todo sergeyp: Results of all index merge selects actually are ordered
       by clustered PK values.
     */
 
@@ -5569,8 +5569,8 @@
     Item *item;
     Item_field *field;
     int cur_pos_in_select_list= 0;
-    List<Item>::iterator li(fields);
-    List<Item_field>::iterator naf_it(session->getLex()->current_select->non_agg_fields);
+    List<Item>::iterator li(fields.begin());
+    List<Item_field>::iterator naf_it(session->getLex()->current_select->non_agg_fields.begin());
 
     field= naf_it++;
     while (field && (item=li++))
@@ -5596,8 +5596,7 @@
             if ((*ord->item)->eq((Item*)field, 0))
               goto next_field;
           /*
-            TODO: change ER_WRONG_FIELD_WITH_GROUP to more detailed
-            ER_NON_GROUPING_FIELD_USED
+            @todo change ER_WRONG_FIELD_WITH_GROUP to more detailed ER_NON_GROUPING_FIELD_USED
           */
           my_error(ER_WRONG_FIELD_WITH_GROUP, MYF(0), field->full_name());
           return 1;
@@ -5626,7 +5625,7 @@
                                 List<Item> &,
                                 bool *all_order_by_fields_used)
 {
-  List<Item>::iterator li(fields);
+  List<Item>::iterator li(fields.begin());
   Item *item;
   Order *order,*group,**prev;
 
@@ -5690,7 +5689,7 @@
 */
 void count_field_types(Select_Lex *select_lex, Tmp_Table_Param *param, List<Item> &fields, bool reset_with_sum_func)
 {
-  List<Item>::iterator li(fields);
+  List<Item>::iterator li(fields.begin());
   Item *field;
 
   param->field_count=param->sum_func_count=param->func_count=
@@ -5747,7 +5746,7 @@
 */
 int test_if_item_cache_changed(List<Cached_item> &list)
 {
-  List<Cached_item>::iterator li(list);
+  List<Cached_item>::iterator li(list.begin());
   int idx= -1,i;
   Cached_item *buff;
 
@@ -5796,11 +5795,11 @@
                        List<Item> &all_fields)
 {
   Item *pos;
-  List<Item>::iterator li(all_fields);
+  List<Item>::iterator li(all_fields.begin());
   CopyField *copy= NULL;
   res_selected_fields.clear();
   res_all_fields.clear();
-  List<Item>::iterator itr(res_all_fields);
+  List<Item>::iterator itr(res_all_fields.begin());
   List<Item> extra_funcs;
   uint32_t i, border= all_fields.elements - elements;
 
@@ -5877,8 +5876,8 @@
 	     !real_pos->with_sum_func)
     {						// Save for send fields
       pos= real_pos;
-      /* TODO:
-        In most cases this result will be sent to the user.
+      /* 
+        @todo In most cases this result will be sent to the user.
         This should be changed to use copy_int or copy_real depending
         on how the value is to be used: In some cases this may be an
         argument in a group function, like: IF(ISNULL(col),0,COUNT(*))
@@ -5932,7 +5931,7 @@
   for (; ptr != end; ptr++)
     (*ptr->do_copy)(ptr);
 
-  List<Item>::iterator it(param->copy_funcs);
+  List<Item>::iterator it(param->copy_funcs.begin());
   Item_copy_string *item;
   while ((item = (Item_copy_string*) it++))
     item->copy();
@@ -5961,7 +5960,7 @@
 			                        uint32_t elements,
                               List<Item> &all_fields)
 {
-  List<Item>::iterator it(all_fields);
+  List<Item>::iterator it(all_fields.begin());
   Item *item_field,*item;
 
   res_selected_fields.clear();
@@ -6010,7 +6009,7 @@
       item_field;
   }
 
-  List<Item>::iterator itr(res_all_fields);
+  List<Item>::iterator itr(res_all_fields.begin());
   for (i= 0; i < border; i++)
     itr++;
   itr.sublist(res_selected_fields, elements);
@@ -6040,7 +6039,7 @@
                                uint32_t elements,
 			                         List<Item> &all_fields)
 {
-  List<Item>::iterator it(all_fields);
+  List<Item>::iterator it(all_fields.begin());
   Item *item, *new_item;
   res_selected_fields.clear();
   res_all_fields.clear();
@@ -6053,7 +6052,7 @@
       new_item;
   }
 
-  List<Item>::iterator itr(res_all_fields);
+  List<Item>::iterator itr(res_all_fields.begin());
   for (i= 0; i < border; i++)
     itr++;
   itr.sublist(res_selected_fields, elements);
@@ -6145,7 +6144,7 @@
     /*
       Need to check the THD error state because Item::val_xxx() don't
       return error code, but can generate errors
-      TODO: change it for a real status check when Item::val_xxx()
+      @todo change it for a real status check when Item::val_xxx()
       are extended to return status code.
     */
     if (session->is_error())
@@ -6203,7 +6202,7 @@
   @param changed        out:  returns 1 if item contains a replaced field item
 
   @todo
-    - TODO: Some functions are not null-preserving. For those functions
+    - @todo Some functions are not null-preserving. For those functions
     updating of the maybe_null attribute is an overkill.
 
   @retval
@@ -6293,7 +6292,7 @@
                 List<TableList> *tables, enum_query_type)
 {
   /* List is reversed => we should reverse it before using */
-  List<TableList>::iterator ti(*tables);
+  List<TableList>::iterator ti(tables->begin());
   TableList **table= (TableList **)session->getMemRoot()->allocate(sizeof(TableList*) *
                                                 tables->elements);
   if (table == 0)
@@ -6330,7 +6329,7 @@
 
   //Item List
   bool first= 1;
-  List<Item>::iterator it(item_list);
+  List<Item>::iterator it(item_list.begin());
   Item *item;
   while ((item= it++))
   {
@@ -6343,7 +6342,7 @@
 
   /*
     from clause
-    TODO: support USING/FORCE/IGNORE index
+    @todo support USING/FORCE/IGNORE index
   */
   if (table_list.elements)
   {

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-02-21 18:33:47 +0000
+++ drizzled/sql_table.cc	2011-02-22 00:55:58 +0000
@@ -557,8 +557,8 @@
   int		timestamps= 0, timestamps_with_niladic= 0;
   int		dup_no;
   int		select_field_pos,auto_increment=0;
-  List<CreateField>::iterator it(alter_info->create_list);
-  List<CreateField>::iterator it2(alter_info->create_list);
+  List<CreateField>::iterator it(alter_info->create_list.begin());
+  List<CreateField>::iterator it2(alter_info->create_list.begin());
   uint32_t total_uneven_bit_length= 0;
 
   plugin::StorageEngine *engine= plugin::StorageEngine::findByName(create_proto.engine().name());
@@ -652,7 +652,7 @@
         interval= sql_field->interval= typelib(session->mem_root,
                                                sql_field->interval_list);
 
-        List<String>::iterator int_it(sql_field->interval_list);
+        List<String>::iterator int_it(sql_field->interval_list.begin());
         String conv, *tmp;
         char comma_buf[4];
         int comma_length= cs->cset->wc_mb(cs, ',', (unsigned char*) comma_buf,
@@ -829,8 +829,8 @@
 
   /* Create keys */
 
-  List<Key>::iterator key_iterator(alter_info->key_list);
-  List<Key>::iterator key_iterator2(alter_info->key_list);
+  List<Key>::iterator key_iterator(alter_info->key_list.begin());
+  List<Key>::iterator key_iterator2(alter_info->key_list.begin());
   uint32_t key_parts=0, fk_key_count=0;
   bool primary_key=0,unique_key=0;
   Key *key, *key2;
@@ -992,8 +992,8 @@
 
     message::Table::Field *protofield= NULL;
 
-    List<Key_part_spec>::iterator cols(key->columns);
-    List<Key_part_spec>::iterator cols2(key->columns);
+    List<Key_part_spec>::iterator cols(key->columns.begin());
+    List<Key_part_spec>::iterator cols2(key->columns.begin());
     for (uint32_t column_nr=0 ; (column=cols++) ; column_nr++)
     {
       uint32_t length;
@@ -1883,7 +1883,7 @@
     session->getLex()->cleanup_after_one_table_open();
     session->clear_error();  // these errors shouldn't get client
     {
-      List<DRIZZLE_ERROR>::iterator it(session->warn_list);
+      List<DRIZZLE_ERROR>::iterator it(session->warn_list.begin());
       DRIZZLE_ERROR *err;
       while ((err= it++))
       {

=== modified file 'drizzled/sql_union.cc'
--- drizzled/sql_union.cc	2011-02-21 18:33:47 +0000
+++ drizzled/sql_union.cc	2011-02-22 00:55:58 +0000
@@ -308,7 +308,7 @@
       assert(!empty_table);
       empty_table= (Table*) session->calloc(sizeof(Table));
       types.clear();
-      List<Item>::iterator it(sl->item_list);
+      List<Item>::iterator it(sl->item_list.begin());
       Item *item_tmp;
       while ((item_tmp= it++))
       {
@@ -327,8 +327,8 @@
 		   ER(ER_WRONG_NUMBER_OF_COLUMNS_IN_SELECT),MYF(0));
 	goto err;
       }
-      List<Item>::iterator it(sl->item_list);
-      List<Item>::iterator tp(types);
+      List<Item>::iterator it(sl->item_list.begin());
+      List<Item>::iterator tp(types.begin());
       Item *type, *item_tmp;
       while ((type= tp++, item_tmp= it++))
       {
@@ -344,7 +344,7 @@
       Check that it was possible to aggregate
       all collations together for UNION.
     */
-    List<Item>::iterator tp(types);
+    List<Item>::iterator tp(types.begin());
     Item *type;
     uint64_t create_options;
 

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2011-02-21 18:33:47 +0000
+++ drizzled/statement/alter_table.cc	2011-02-22 00:55:58 +0000
@@ -255,12 +255,12 @@
   List<CreateField> new_create_list;
   /* New key definitions are added here */
   List<Key> new_key_list;
-  List<AlterDrop>::iterator drop_it(alter_info->drop_list);
-  List<CreateField>::iterator def_it(alter_info->create_list);
-  List<AlterColumn>::iterator alter_it(alter_info->alter_list);
-  List<Key>::iterator key_it(alter_info->key_list);
-  List<CreateField>::iterator find_it(new_create_list);
-  List<CreateField>::iterator field_it(new_create_list);
+  List<AlterDrop>::iterator drop_it(alter_info->drop_list.begin());
+  List<CreateField>::iterator def_it(alter_info->create_list.begin());
+  List<AlterColumn>::iterator alter_it(alter_info->alter_list.begin());
+  List<Key>::iterator key_it(alter_info->key_list.begin());
+  List<CreateField>::iterator find_it(new_create_list.begin());
+  List<CreateField>::iterator field_it(new_create_list.begin());
   List<Key_part_spec> key_parts;
   uint32_t used_fields= create_info->used_fields;
   KeyInfo *key_info= table->key_info;
@@ -1487,7 +1487,7 @@
   from->cursor->info(HA_STATUS_VARIABLE | HA_STATUS_NO_LOCK);
   to->cursor->ha_start_bulk_insert(from->cursor->stats.records);
 
-  List<CreateField>::iterator it(create);
+  List<CreateField>::iterator it(create.begin());
   CreateField *def;
   copy_end= copy;
   for (Field **ptr= to->getFields(); *ptr ; ptr++)

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2011-02-21 18:33:47 +0000
+++ drizzled/table.cc	2011-02-22 04:11:07 +0000
@@ -197,7 +197,7 @@
 
 /* Deallocate temporary blob storage */
 
-void free_blobs(register Table *table)
+void free_blobs(Table *table)
 {
   uint32_t *ptr, *end;
   for (ptr= table->getBlobField(), end=ptr + table->sizeBlobFields();
@@ -223,7 +223,7 @@
     
   result->type_lengths= (uint*) (result->type_names + result->count + 1);
 
-  List<String>::iterator it(strings);
+  List<String>::iterator it(strings.begin());
   String *tmp;
   for (uint32_t i= 0; (tmp= it++); i++)
   {
@@ -239,7 +239,7 @@
 
 	/* Check that the integer is in the internal */
 
-int set_zone(register int nr, int min_zone, int max_zone)
+int set_zone(int nr, int min_zone, int max_zone)
 {
   if (nr<=min_zone)
     return (min_zone);
@@ -874,7 +874,7 @@
   blob_count= string_count= null_count= hidden_null_count= group_null_items= 0;
   param->using_indirect_summary_function= 0;
 
-  List<Item>::iterator li(fields);
+  List<Item>::iterator li(fields.begin());
   Item *item;
   Field **tmp_from_field=from_field;
   while ((item=li++))

=== modified file 'drizzled/table/singular.cc'
--- drizzled/table/singular.cc	2011-02-20 00:09:56 +0000
+++ drizzled/table/singular.cc	2011-02-22 00:51:13 +0000
@@ -59,7 +59,7 @@
   in_use= session;           /* field_arg->reset() may access in_use */
 
   /* Create all fields and calculate the total length of record */
-  List<CreateField>::iterator it(field_list);
+  List<CreateField>::iterator it(field_list.begin());
   message::Table::Field null_field;
   while ((cdef= it++))
   {

=== modified file 'drizzled/table_list.cc'
--- drizzled/table_list.cc	2011-02-20 00:09:56 +0000
+++ drizzled/table_list.cc	2011-02-22 00:51:13 +0000
@@ -94,7 +94,7 @@
     */
     if ((cur_table_ref->outer_join & JOIN_TYPE_RIGHT))
     {
-      List<TableList>::iterator it(cur_nested_join->join_list);
+      List<TableList>::iterator it(cur_nested_join->join_list.begin());
       TableList *next;
       cur_table_ref= it++;
       while ((next= it++))
@@ -124,7 +124,7 @@
        cur_nested_join;
        cur_nested_join= cur_table_ref->nested_join)
   {
-    List<TableList>::iterator it(cur_nested_join->join_list);
+    List<TableList>::iterator it(cur_nested_join->join_list.begin());
     cur_table_ref= it++;
     /*
       If the current nested join is a RIGHT JOIN, the operands in
@@ -165,7 +165,7 @@
     int type;
     bool have_empty_use_join= false, have_empty_use_order= false,
          have_empty_use_group= false;
-    List_iterator <Index_hint> iter(*index_hints);
+    List_iterator <Index_hint> iter(index_hints->begin());
 
     /* initialize temporary variables used to collect hints of each kind */
     for (type= INDEX_HINT_IGNORE; type <= INDEX_HINT_FORCE; type++)
@@ -309,7 +309,7 @@
 
     if (index_hints)
     {
-      List<Index_hint>::iterator it(*index_hints);
+      List<Index_hint>::iterator it(index_hints->begin());
       Index_hint *hint;
 
       while ((hint= it++))

=== modified file 'drizzled/table_proto_write.cc'
--- drizzled/table_proto_write.cc	2011-02-18 11:56:54 +0000
+++ drizzled/table_proto_write.cc	2011-02-21 22:12:35 +0000
@@ -52,7 +52,7 @@
                       KeyInfo *key_info)
 {
   CreateField *field_arg;
-  List<CreateField>::iterator it(create_fields);
+  List<CreateField>::iterator it(create_fields.begin());
   message::Table::TableOptions *table_options= table_proto.mutable_options();
 
   if (create_fields.elements > MAX_FIELDS)

=== modified file 'drizzled/thr_lock.cc'
--- drizzled/thr_lock.cc	2011-02-17 00:14:13 +0000
+++ drizzled/thr_lock.cc	2011-02-22 06:09:35 +0000
@@ -91,8 +91,6 @@
 
 uint64_t max_write_lock_count= UINT64_MAX;
 
-void thr_multi_unlock(THR_LOCK_DATA **data,uint32_t count);
-
 /*
 ** For the future (now the thread specific cond is alloced by my_pthread.c)
 */

=== modified file 'plugin/console/console.cc'
--- plugin/console/console.cc	2011-02-20 00:09:56 +0000
+++ plugin/console/console.cc	2011-02-21 18:49:48 +0000
@@ -187,7 +187,7 @@
 
   virtual bool sendFields(List<Item> *list)
   {
-    List<Item>::iterator it(*list);
+    List<Item>::iterator it(list->begin());
     Item *item;
 
     column= 0;

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-02-15 20:03:56 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-02-22 06:09:35 +0000
@@ -8787,16 +8787,6 @@
 finds charset information and returns length of prefix_len characters in the
 index field in bytes.
 @return number of bytes occupied by the first n characters */
-UNIV_INTERN
-ulint
-innobase_get_at_most_n_mbchars(
-/*===========================*/
-  ulint charset_id, /*!< in: character set id */
-  ulint prefix_len, /*!< in: prefix length in bytes of the index
-        (this has to be divided by mbmaxlen to get the
-        number of CHARACTERS n in the prefix) */
-  ulint data_len,   /*!< in: length of the string in bytes */
-  const char* str); /*!< in: character string */
 
 ulint
 innobase_get_at_most_n_mbchars(

=== modified file 'plugin/mysql_protocol/mysql_protocol.cc'
--- plugin/mysql_protocol/mysql_protocol.cc	2011-02-20 10:23:17 +0000
+++ plugin/mysql_protocol/mysql_protocol.cc	2011-02-22 04:11:07 +0000
@@ -478,7 +478,7 @@
 */
 bool ClientMySQLProtocol::sendFields(List<Item> *list)
 {
-  List<Item>::iterator it(*list);
+  List<Item>::iterator it(list->begin());
   Item *item;
   unsigned char buff[80];
   String tmp((char*) buff,sizeof(buff),&my_charset_bin);

=== removed file 'plugin/transaction_log/background_worker.cc'
--- plugin/transaction_log/background_worker.cc	2011-02-17 00:14:13 +0000
+++ plugin/transaction_log/background_worker.cc	1970-01-01 00:00:00 +0000
@@ -1,97 +0,0 @@
-/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2009 Sun Microsystems, Inc.
- *
- *  Authors:
- *
- *  Jay Pipes <joinfu@sun.com>
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-/**
- * @file
- *
- * Defines the implementation of the background worker thread
- * which maintains summary information about transaction log.
- *
- * @details
- *
- * The general process that the background worker (collector) thread goes through
- * is the following:
- *
- * a) At thread start, we first check to see if there is an index
- *    file for the transaction log that has previously been written
- *    by the collector thread.  If there is, we read in the index and
- *    use that information to construct our in-memory index.
- *
- * b) If no index is around, we read the transaction log and create
- *    an in-memory index.  This in-memory index is sync'd to disk 
- *    every once in a while.  We don't care about crashes and the state
- *    of the index written to disk, since the transaction log file is
- *    the main stable state of the transaction log, not the index.
- *
- * c) Periodically, the collector thread queries the transaction
- *    log's current offset.  If this offset is greater than the last 
- *    offset in the collector's index, it reads a segment of the transaction
- *    log, building the index for the transactions it finds.
- *
- * d) When querying the INFORMATION_SCHEMA, or the replication system
- *    needs an exact read of the index, the collector thread is signalled
- *    via a pthread_cond_broadcast() call and the collector thread reads
- *    the transaction log up until the last log offset of the transaction log,
- *    building the index as it reads the log file.
- */
-
-#include <config.h>
-#include <drizzled/gettext.h>
-#include <drizzled/errmsg_print.h>
-#include <drizzled/definitions.h>
-#include <errno.h>
-
-#include "transaction_log.h"
-#include "background_worker.h"
-
-bool initTransactionLogBackgroundWorker()
-{
-  pthread_t thread;
-  int error;
-  if ((error= pthread_create(&thread, NULL, collectTransactionLogStats, 0)))
-  {
-    drizzled::sql_perror("Unable to create background worker thread.");
-    return true;
-  }
-  return false;
-}
-
-void *collectTransactionLogStats(void *)
-{
-  /* Check to see if there is an index file on disk */
-
-  /* No index file. Create one on disk and in memory. */
-
-  /* Read in the index file. */
-
-  /* Enter collection loop */
-
-  /* Ask for the transaction log's latest written timestamp */
-
-  /* Does our index have a smaller timestamp? */
-
-  pthread_exit(0);
-
-  return NULL;
-}

=== removed file 'plugin/transaction_log/background_worker.h'
--- plugin/transaction_log/background_worker.h	2010-12-18 04:43:40 +0000
+++ plugin/transaction_log/background_worker.h	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2009 Sun Microsystems, Inc.
- *
- *  Authors:
- *
- *  Jay Pipes <joinfu@sun.com>
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-/**
- * @file
- *
- * Defines the methods used by the background worker thread which
- * maintains summary information about the transaction log.
- */
-
-#ifndef PLUGIN_TRANSACTION_LOG_BACKGROUND_WORKER_H
-#define PLUGIN_TRANSACTION_LOG_BACKGROUND_WORKER_H
-
-#include <pthread.h>
-
-/**
- * Initializes the background worker thread
- *
- * @return false on success; true on failure
- */
-bool initTransactionLogBackgroundWorker();
-
-/**
- * The routine which the background worker executes
- */
-extern "C" {
-  void *collectTransactionLogStats(void *arg);
-}
-
-#endif /* PLUGIN_TRANSACTION_LOG_BACKGROUND_WORKER_H */

=== modified file 'plugin/transaction_log/module.cc'
--- plugin/transaction_log/module.cc	2011-02-17 00:14:13 +0000
+++ plugin/transaction_log/module.cc	2011-02-21 19:16:54 +0000
@@ -38,7 +38,6 @@
 #include "data_dictionary_schema.h"
 #include "print_transaction_message.h"
 #include "hexdump_transaction_message.h"
-#include "background_worker.h"
 
 #include <errno.h>
 
@@ -230,13 +229,6 @@
     hexdump_transaction_message_func_factory=
       new plugin::Create_function<HexdumpTransactionMessageFunction>("hexdump_transaction_message");
     context.add(hexdump_transaction_message_func_factory);
-
-    /* 
-     * Setup the background worker thread which maintains
-     * summary information about the transaction log.
-     */
-    if (initTransactionLogBackgroundWorker())
-      return 1; /* Error message output handled in function above */
   }
   return 0;
 }

=== modified file 'plugin/transaction_log/plugin.ini'
--- plugin/transaction_log/plugin.ini	2010-10-26 20:40:42 +0000
+++ plugin/transaction_log/plugin.ini	2011-02-21 19:16:54 +0000
@@ -5,8 +5,8 @@
 license=PLUGIN_LICENSE_GPL
 title=Transaction Log
 description=Log of Transaction Messages
-sources= background_worker.cc hexdump_transaction_message.cc module.cc print_transaction_message.cc transaction_log.cc transaction_log_applier.cc transaction_log_entry.cc transaction_log_index.cc transaction_log_reader.cc data_dictionary_schema.cc write_buffer.cc
-headers= background_worker.h hexdump_transaction_message.h print_transaction_message.h transaction_log.h transaction_log_applier.h transaction_log_entry.h transaction_log_index.h transaction_log_reader.h data_dictionary_schema.h write_buffer.h
+sources= hexdump_transaction_message.cc module.cc print_transaction_message.cc transaction_log.cc transaction_log_applier.cc transaction_log_entry.cc transaction_log_index.cc transaction_log_reader.cc data_dictionary_schema.cc write_buffer.cc
+headers= hexdump_transaction_message.h print_transaction_message.h transaction_log.h transaction_log_applier.h transaction_log_entry.h transaction_log_index.h transaction_log_reader.h data_dictionary_schema.h write_buffer.h
 libs=${top_builddir}/drizzled/algorithm/libhash.la 
 libadd=$(LIBZ)
 cxxflags=${PROTOSKIP_WARNINGS}

=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2011-02-14 17:05:06 +0000
+++ po/POTFILES.in	2011-02-21 19:16:54 +0000
@@ -96,7 +96,6 @@
 plugin/syslog/function.cc
 plugin/syslog/logging.cc
 plugin/syslog/module.cc
-plugin/transaction_log/background_worker.cc
 plugin/transaction_log/hexdump_transaction_message.cc
 plugin/transaction_log/module.cc
 plugin/transaction_log/print_transaction_message.cc

=== modified file 'tests/valgrind.supp'
--- tests/valgrind.supp	2011-02-07 23:10:42 +0000
+++ tests/valgrind.supp	2011-02-21 19:16:54 +0000
@@ -468,17 +468,6 @@
    fun:_ZN8drizzled13handle_selectEPNS_7SessionEPNS_3LEXEPNS_13select_resultEy
 }
 
-# https://bugs.launchpad.net/drizzle/+bug/582526
-{
-   Possibly lack of deallocation of a thread
-   Memcheck:Leak
-   fun:calloc
-   ...
-   fun:pthread_create*
-   fun:_Z34initTransactionLogBackgroundWorkerv
-   ...
-}
-
 # Issues with boost::thread
 {
   Boost::thread issues. Not a problem - static init issues.

